﻿# Define variables
$tenant = "contoso";
$targetSite = "/sites/department/template/";
$templateFile = "C:\path\to\file\temnplate.xml";
$siteTitle = "New Publishing Site";
$siteDescription = "Publishing site created with PnP Provisioning";
$siteUrl = "PnPSite";
 
# Office 365 Login 
$webUrl = "https://{0}.sharepoint.com{1}/" -f $tenant, $targetSite;
Write-Output $("Connecting to {0}" -f $webUrl);
Connect-PnPOnline -Url $webUrl -Credentials WCMStoredCredentials;
#use the line bellow to connect if you are using multi factor authentication  
#Connect-PnPOnline -Url $webUrl -UseWebLogin;
  
# Get site context
Write-Output $("Getting site context {0}" -f $siteTitle);
$newSite = (Get-PnPWeb).ServerRelativeUrl + "/" + $siteUrl

# If the site does not exist creates it
if((Get-PnPSubWebs).ServerRelativeUrl -contains $newSite){
    #Get site context
    $web = Get-PnPWeb -Identity $newSite
} else {
    #Creates the publishing site and gets context
    $web = New-PnpWeb -Title "$siteTitle" -Url "$siteUrl" -Description "$siteDescription" -Locale 1033 -Template "BLANKINTERNET#0"
}

# Apply template
Write-Output $("Applying PnP template [{0}] to site [{1} ({2})]" -f $templateFile, $web.Title, $web.Url);
Set-PnPTraceLog -On -LogFile "C:\path\to\file\log.txt" -Level Debug
Apply-PnPProvisioningTemplate -Web $web -Path $templateFile 
